# puppet-snmpd ![License badge][license-img]

1. [Overview](#overview)
2. [Description](#module-description)
3. [Setup](#setup)
4. [Usage](#usage)
5. [Limitations](#limitations)
6. [Development](#development)
7. [Miscellaneous](#miscellaneous)

## Overview

Simple  Network  Management Protocol  (SNMP)  is  a  widely used  protocol  for
monitoring the health and welfare  of network equipment (eg. routers), computer
equipment and even devices like UPSs.

[net-snmp.org](http://www.net-snmp.org/)

## Description

This module enables you to install, deploy, and configure snmpd.

## Setup

Copy this module in your modules folder without *puppet-* in the name.

or

```bash
puppet module install vpgrp-snmpd
```

## Usage

```puppet
class { 'snmpd':
  package       => true,
  service       => true,
  allowed_hosts => [ '10.0.0.0/8', '192.168.0.0/16' ],
  community     => 'public',
  syslocation   => 'Some place in Netherlands',
  syscontact    => 'root'
}
```

## Limitations

So far, this is compatible with Debian, RedHat, and other derivatives.

## Development

Please read carefully CONTRIBUTING.md before making a merge request.

## Miscellaneous

```
    ╚⊙ ⊙╝
  ╚═(███)═╝
 ╚═(███)═╝
╚═(███)═╝
 ╚═(███)═╝
  ╚═(███)═╝
   ╚═(███)═╝
```

[license-img]: https://img.shields.io/badge/license-Apache-blue.svg
