# == Class: snmpd::extend
define snmpd::extend (
  $ensure       = present,
  $content      = undef,
  $source       = undef,
  $dest         = undef,
  $package_name = $snmpd::params::snmpd_package_name,
  $service_name = $snmpd::params::snmpd_service_name
) {
  file { $dest:
    ensure  => $ensure,
    content => $content,
    source  => $source,
    owner   => 'root',
    group   => 'root',
    mode    => '0755',
    require => Package[$package_name],
    notify  => Service[$service_name]
  }
}
