# -*- puppet -*-

exec { 'yum update':
  command => 'yum update -q -y',
  path    => [ '/usr/bin', '/usr/sbin', '/bin', '/sbin' ],
}

class { 'snmpd':
  package       => true,
  service       => true,
  secname       => 'test',
  allowed_hosts => [ '127.0.0.1', '10.0.0.0/8' ],
  community     => 'private',
  syslocation   => 'kitchen',
  syscontact    => 'root',
  require       => Exec[ 'yum update' ],
  extend        => [
    {
      'name' => 'powerdns',
      'dest' => '/usr/local/bin/powerdns.php',
      'args' => ''
    }
  ]
}

snmpd::extend {
  'powerdns':
    source => 'puppet:///modules/snmpd/powerdns.php',
    dest   => '/usr/local/bin/powerdns.php'
}
# EOF
